              #include <p12f675.inc>
              LIST        p=12F675          ;   .
              __CONFIG    03F81H            ;   4( 3F81)

Sec           equ         20h
Sec2          equ         21h
Sec1          equ         22h
var           equ         23h
kod           equ         24h
shetbit       equ         25h
Sec3          equ         26h
crc           equ         27h

dstemp        equ         2Eh
temp          equ         2Fh
flag1         equ         28h
reseivebyte   equ         30h
sendbyte      equ         31h

#define       datchik     GPIO,2            ;(1)   -
#define       dat         GPIO,1            ;(0)

              org         0                 ;      0 PC.
              goto        Start             ;    Start.
      
Start         movlw       b'00000111'       ; 
              movwf       CMCON             ;
              movlw       b'00000000'       ;      GPIO
              movwf       GPIO              ;
              bsf         STATUS,RP0        ; 1- 
              movlw       b'00111100'       ;  \  GPIO
              movwf       TRISIO            ;GP2- ,  
              movlw       b'11011111'       ;  \  GPIO
              movwf       OPTION_REG            ;
              movlw       b'00000001'       ;
              movwf       IOCB
              movlw       b'11111000'       ;
              movwf       WPU
              bcf         ANSEL,ANS0        ;(1)GP1- 
              bcf         ANSEL,ANS2        ;GP1- 
              bcf         STATUS,RP0        ; 0- 

             
              call        thermometer 
              call        paus_sec          ; 1                 
began         call        thermometer
              
              clrf        crc              ;     
              movf        dstemp,W
              call        crc_8
              movf        temp,W
              call        crc_8
              

              movlw       .3
              movwf       Sec3
                    
povtor1       call        preamb            ;   
              movf        dstemp,W              ;  46  
              call        send  
              movf        temp,W              ;  46  
              call        send             ; 
              movf        crc,W              ;  55   (  .)
              call        send              ;
 
              call        pause10
              decfsz      Sec3,F
              goto        povtor1
              
              bsf        STATUS,RP0                 ;  
              bsf        TRISIO,0             ;(2)
              bcf        STATUS,RP0
              movf       GPIO,W
              bcf         INTCON,GPIF         ;INTF
              bsf         INTCON,GPIE         ;INTE
              
              SLEEP
              nop
              bcf        INTCON,GPIE        ;(INTE)
              bcf        GPIO,0            ;(2)
              bsf        STATUS,RP0                 ;  
              bcf        TRISIO,0          ;(2)
              bcf        STATUS,RP0
              call        paus_cap                  ;    
              goto        began                 ;

send          movwf       kod
              movlw       .8                ;  8   shetbit,   
              movwf       shetbit           ;  
opros         btfsc       kod,7             ; 7-   kod
              goto        prdedin           ;  1:   prdedin 

prdnol        bcf         dat               ;  0:  
              call        paus800
              bsf         dat
              call        paus400
              goto        metka1
                          
prdedin       bcf         dat               ;  
              call        paus400
              bsf         dat
              call        paus800

metka1        rlf         kod,F             ;   kod   
                                            ; 
              decfsz      shetbit,F         ;   
              goto        opros             ;   :   opros
              bcf         dat               ;  :   dat(   
                                            ;    )
              return                        ;  


thermometer     call     init_therm         
                btfss    flag1,1
                goto     ds_enable
dserror         movlw    b'10101010'
                movwf    dstemp
                movwf    temp
                return


        
		
ds_enable       movlw    0xCC	            ; 
                call     send1
                movlw    0x44
                call     send1

end_ansv1       btfss    datchik	     ;  
                goto     end_ansv1
                call     init_therm        ; 
                movlw    0xCC	           ; 
                call     send1
                movlw    0xBE
                call     send1
                call     reseive
                movwf    dstemp
                call     reseive
                movwf    temp
                return
               
    

init_therm      bcf          flag1,1	            ;,   
                movlw        .20	            ;  
                movwf        Sec1
                call         ds_comm
                bcf          datchik	          ;
                movlw        .170	            ; 500 
                movwf        Sec
delinittherm    decfsz       Sec,F
                goto         delinittherm
                bsf          datchik
                call         ds_data
init_ansv       btfss        datchik	           ; 
                goto         end_ansv
                decfsz      Sec1,F
                goto        init_ansv
                bsf         flag1,1	      ;   >  
                return

end_ansv        btfss       datchik	     ;  
                goto        end_ansv
                return
               

send1           movwf       sendbyte	      ;  
                movlw      .8
                movwf        Sec1
sendloop        call       ds_comm
                rrf        sendbyte,F
                btfsc      STATUS,C
                bsf        datchik
                call       wait50
                call       ds_data
                decfsz     Sec1,F
                goto       sendloop
                return
		
reseive         movlw      .8
                movwf     Sec1
reseiveloop     call      ds_comm
                call      ds_data
                bcf       STATUS,C
                btfsc     datchik
                bsf       STATUS,C
                rrf       reseivebyte,F 
                call      wait50
                decfsz    Sec1,F
                goto      reseiveloop
                movf      reseivebyte,W
                return



ds_comm       bcf        datchik                    ;  
              bsf        STATUS,RP0
              bcf        TRISIO,2
              bcf        STATUS,RP0
              return


ds_data       bsf        STATUS,RP0                 ;  
              bsf        TRISIO,2
              bcf        STATUS,RP0
              return





preamb        movlw       .8                ;    -
              movwf       var               ;-      
bb1           bcf         dat               ;(010101...01) 16  - 2 
              call        paus400
              bsf         dat
              call        paus400
              decfsz      var,F
              goto        bb1
              return


crc_8         xorwf       crc,F           ;   
              clrw
              btfsc       crc,7
              xorlw       0x7A
              btfsc       crc,6
              xorlw       0x3D
              btfsc       crc,5
              xorlw       0x86
              btfsc       crc,4
              xorlw       0x43
              btfsc       crc,3
              xorlw       0xB9
              btfsc       crc,2
              xorlw       0xC4
              btfsc       crc,1
              xorlw       0x62
              btfsc       crc,0
              xorlw       0x31
              movwf       crc
              return

paus_cap      movlw       .5               ;  114
              movwf       Sec1
a3            movlw       .130               ;  114
              movwf       Sec
a2            movlw       .255
              movwf       Sec2
a1            decfsz      Sec2,F
              goto        a1
              decfsz      Sec,F
              goto        a2
              decfsz      Sec1,F
              goto        a3
              return


pause10       movlw       .13               ;  10
              movwf       Sec
ar2           movlw       .255
              movwf       Sec2
ar1           decfsz      Sec2,F
              goto        ar1
              decfsz      Sec,F
              goto        ar2
              return

wait50        movlw       .12                     ; 50
              movwf       Sec
loop50        nop
              decfsz      Sec,F
              goto        loop50
              return



paus400       movlw       .132               ;  400
              movwf       Sec2
aa1           decfsz      Sec2,F
              goto        aa1
              return 

paus800       movlw       .4              ;  800
              movwf       Sec2
aa3           movlw       .66              
              movwf       Sec1
aa2           decfsz      Sec1,F
              goto        aa2
              decfsz      Sec2,F
              goto        aa3
              return 

paus_sec      movlw       .5                ;  1
              movwf       Sec
as2           movlw       .255
              movwf       Sec2
as3           movlw       .255
              movwf       Sec1
as1           decfsz      Sec1,F
              goto        as1
              decfsz      Sec2,F
              goto        as3
              decfsz      Sec,F
              goto        as2
              return

              End                            ;  